diff -uNrd ircd-ratbox-1.3-1/src/channel_mode.c ircd-1.4-FreedomBG/src/channel_mode.c
--- ircd-ratbox-1.3-1/src/channel_mode.c	Thu Nov  6 19:00:44 2003
+++ ircd-1.4-FreedomBG/src/channel_mode.c	Thu May 13 20:31:40 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel_mode.c,v 7.107.2.7 2003/11/07 00:00:44 leeh Exp $
+ *  $Id: channel_mode.c,v 9.1 2004/05/07 11:01:22 castello Exp $
  */
 
 #include "stdinc.h"
@@ -333,6 +333,27 @@
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
 
+#ifdef FreedomBG
+	if (chptr->mode.mode & MODE_NOCOLOR)
+    		*mbuf++ = 'c';
+        
+	// from ircd fuis
+	if (chptr->mode.mode & MODE_NOTALK)
+		*mbuf++ = 'M';
+	if (chptr->mode.mode & MODE_NOSPAM)
+		*mbuf++ = 'H';
+	if (chptr->mode.mode & MODE_NOREPEAT)
+		*mbuf++ = 'z';
+	if (chptr->mode.mode & MODE_NOCTCP)
+		*mbuf++ = 'C';
+	if (chptr->mode.mode & MODE_JOINF)
+		*mbuf++ = 'q';
+	if (chptr->mode.mode & MODE_ADMONLY)
+		*mbuf++ = 'A';
+	if (chptr->mode.mode & MODE_OPRONLY)
+		*mbuf++ = 'O';
+#endif /* FreedomBG */
+
 	if(chptr->mode.limit)
 	{
 		*mbuf++ = 'l';
@@ -1043,6 +1064,16 @@
 		return;
 	}
 
+#ifdef FreedomBG
+	
+	if ((dir == MODE_DEL) && s_check(opnick))
+	{
+        sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, source_p->name, opnick);
+             return;
+	}
+#endif
+
 	if(MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
 		return;
 
@@ -1275,21 +1306,41 @@
 static struct ChannelMode ModeTable[255] =
 {
   {chm_nosuch, NULL},
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_ADMONLY},            /* A */
+#else
   {chm_nosuch, NULL},                             /* A */
+#endif
   {chm_nosuch, NULL},                             /* B */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_NOCTCP},             /* C */
+#else
   {chm_nosuch, NULL},                             /* C */
+#endif
   {chm_nosuch, NULL},                             /* D */
   {chm_nosuch, NULL},                             /* E */
   {chm_nosuch, NULL},                             /* F */
   {chm_nosuch, NULL},                             /* G */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_NOSPAM},             /* H */
+#else
   {chm_nosuch, NULL},                             /* H */
+#endif
   {chm_invex, NULL},                              /* I */
   {chm_nosuch, NULL},                             /* J */
   {chm_nosuch, NULL},                             /* K */
   {chm_nosuch, NULL},                             /* L */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_NOTALK},             /* M */
+#else
   {chm_nosuch, NULL},                             /* M */
+#endif
   {chm_nosuch, NULL},                             /* N */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_OPRONLY},            /* O */ 
+#else
   {chm_nosuch, NULL},                             /* O */
+#endif
   {chm_nosuch, NULL},                             /* P */
   {chm_nosuch, NULL},                             /* Q */
   {chm_nosuch, NULL},                             /* R */
@@ -1309,7 +1360,11 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},				  /* a */
   {chm_ban, NULL},                                /* b */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
+#else
   {chm_nosuch, NULL},                             /* c */
+#endif
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
@@ -1323,7 +1378,11 @@
   {chm_simple, (void *) MODE_NOPRIVMSGS},         /* n */
   {chm_op, NULL},                                 /* o */
   {chm_simple, (void *) MODE_PRIVATE},            /* p */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_JOINF},              /* q */
+#else
   {chm_nosuch, NULL},                             /* q */
+#endif
   {chm_nosuch, NULL},                             /* r */
   {chm_simple, (void *) MODE_SECRET},             /* s */
   {chm_simple, (void *) MODE_TOPICLIMIT},         /* t */
@@ -1332,7 +1391,11 @@
   {chm_nosuch, NULL},                             /* w */
   {chm_nosuch, NULL},                             /* x */
   {chm_nosuch, NULL},                             /* y */
+#ifdef FreedomBG
+  {chm_simple, (void *) MODE_NOREPEAT},           /* z */
+#else
   {chm_nosuch, NULL},                             /* z */
+#endif
 };
 /* *INDENT-ON* */
 
diff -uNrd ircd-ratbox-1.3-1/src/client.c ircd-1.4-FreedomBG/src/client.c
--- ircd-ratbox-1.3-1/src/client.c	Thu Nov 27 15:20:14 2003
+++ ircd-1.4-FreedomBG/src/client.c	Thu May 13 20:35:53 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: client.c,v 7.385.2.13 2003/11/27 20:20:14 leeh Exp $
+ *  $Id: client.c,v 9.3 2005/05/27 22:22:11 castello Exp $
  */
 #include "stdinc.h"
 #include "config.h"
@@ -57,6 +57,10 @@
 #include "balloc.h"
 #include "listener.h"
 
+#ifdef FreedomBG
+#define SERVICESHOST	"FreedomBG.Services"
+#define GLINERHOST	"FreedomBG.Gliner"
+#endif
 
 static void check_pings_list(dlink_list * list);
 static void check_unknowns_list(dlink_list * list);
@@ -848,6 +852,30 @@
 			--Count.oper;
 		if(IsInvisible(client_p))
 			--Count.invisi;
+
+#ifdef FreedomBG
+		if (IsNSId(client_p)) {
+		    CurrentIdentUsers--;
+			if (CurrentIdentUsers < 0) {
+				CurrentIdentUsers = 0;
+		    }
+		}
+
+		if (IsGLId(client_p)) {
+		    CurrentGlinerUsers--;
+			if (CurrentGlinerUsers < 0) {
+				CurrentGlinerUsers = 0;
+            }
+		}
+
+		if (IsOSId(client_p)) {
+		    CurrentOSidUsers--;
+			if (CurrentOSidUsers < 0) {
+				CurrentOSidUsers = 0;
+            }
+        }
+#endif
+
 	}
 
 	if(splitchecking && !splitmode)
@@ -1147,6 +1175,41 @@
 		   (source_p->flags & FLAGS_KILLED) == 0)
 			sendto_one(target_p, ":%s SQUIT %s :%s", from->name, source_p->name,
 				   comment);
+
+#ifdef FreedomBG
+		if (!strcasecmp(GLINERHOST, source_p->name)) {
+			dlink_node *gptr;
+
+		    CurrentGlinerUsers = 0;
+			for (gptr = global_client_list.head; gptr; gptr = gptr->next) {
+				target_p = gptr->data;
+                if (IsServer(target_p) || IsMe(target_p))
+					    continue;
+				if (IsGLId(target_p)) {
+					   ClearGLId(target_p);
+			    }
+			}
+		}
+
+		if (!strcasecmp(SERVICESHOST, source_p->name)) {
+            dlink_node *ptr;
+	
+            CurrentIdentUsers = 0;
+            CurrentOSidUsers = 0;
+            for (ptr = global_client_list.head; ptr; ptr = ptr->next) {
+				target_p = ptr->data;
+                if (IsServer(target_p) || IsMe(target_p))
+					    continue;
+				if (IsNSId(target_p)) {
+                   ClearNSId(target_p);
+			    }
+                if (IsOSId(target_p)) {
+                   ClearOSId(target_p);
+			    }
+             } 
+        }
+#endif /* FreedomBG */
+
 	}
 	else if(IsPerson(source_p))	/* ...just clean all others with QUIT... */
 	{
@@ -1854,6 +1917,15 @@
 
 	del_all_accepts(source_p);
 
+#ifdef FreedomBG
+	if (IsNSId(source_p)) {
+        CurrentIdentUsers--;
+        if (CurrentIdentUsers < 0)
+                CurrentIdentUsers = 0;
+	    ClearNSId(source_p);
+	}
+#endif
+
 	/* fd_desc is long enough */
 	fd_note(client_p->localClient->fd, "Nick: %s", nick);
 
@@ -2078,3 +2150,70 @@
 		BlockHeapFree(user_heap, user);
 	}
 }
+
+#ifdef FreedomBG
+
+static char cyr2lat[] = {
+  'A', 'B', 'V', 'G', 'D', 'E', 'Z', 'Z', 'I', 'J', 'K', 'L', 'M', 'N',
+  'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'C', '4', '6', '@', 'Y', '#',
+  'J', '#', 'U', 'Q',
+  'a', 'b', 'v', 'g', 'd', 'e', 'z', 'z', 'i', 'j', 'k', 'l', 'm', 'n',
+  'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', '4', '6', '@', 'y', '#',
+  'j', '#', 'u', 'q'
+};
+
+char *translate(struct Client *client_p, char *buf)
+{
+  unsigned char *p = buf;
+  int offset;
+
+  if (IsSetTransWin(client_p))
+    offset = 192;
+  else if (IsSetTransISO(client_p))
+    offset = 176;
+  else
+    return buf;
+
+  while (*p)
+  {
+	if ((*p >= offset) && (*p < offset + 2*32))
+  	  *p = cyr2lat[*p - offset];
+    ++p;
+  }
+
+  return buf;
+}
+
+void add_nokick_chan(struct Client * cptr, char * chan) {
+       dlink_node *nchptr;
+       struct Channel * chptr;
+	ilog(L_ALL,"Added %s to %s nokick",cptr->name,chan);
+       chptr = hash_find_channel(chan);
+       if (!chptr) return;
+       if ((nchptr = dlinkFind(&cptr->user->nokick, chptr)) == NULL)
+		dlinkAddAlloc(chptr, &cptr->user->nokick);
+
+}
+
+void del_nokick_chan(struct Client * cptr, char * chan) {
+       dlink_node *nchptr;
+       struct Channel * chptr;
+	ilog(L_ALL,"Deleted %s to %s nokick",cptr->name,chan);
+       chptr = hash_find_channel(chan);
+       if (!chptr) return;
+       if (nchptr = dlinkFind(&cptr->user->nokick, chptr))
+	    dlinkDestroy(nchptr, &cptr->user->nokick);
+
+}
+
+void clear_nokick_list(struct Client * cptr)  {
+       dlink_node *nchptr;
+       struct Channel * chptr;
+	
+		DLINK_FOREACH(nchptr,cptr->user->nokick.head)
+	    {
+			dlinkDestroy(nchptr, &cptr->user->nokick);
+		}
+		ilog(L_DEBUG,"Nokick list for %s cleared!",cptr->name);
+}
+#endif
diff -uNrd ircd-ratbox-1.3-1/src/messages.tab ircd-1.4-FreedomBG/src/messages.tab
--- ircd-ratbox-1.3-1/src/messages.tab	Thu Nov 20 14:44:39 2003
+++ ircd-1.4-FreedomBG/src/messages.tab	Fri May 14 06:35:51 2004
@@ -21,11 +21,15 @@
 
 static  const char *  replies[] = {
 /* 000 */       NULL,
-/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s",
+/* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s IRC Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
-/* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
+/* 003  RPL_CREATED, */ ":%s 003 %s :This IRC server was created %s",
+#ifdef FreedomBG
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglSTYZ biklmnopstveIqzACHMO bkloveI",
+#else
 /* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglZ biklmnopstveI bkloveI",
-/* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
+#endif
+/* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this FreedomBG IRC Server",
 /* 006 */       NULL,
 /* 007 */       NULL,
 /* 008 */       NULL,
@@ -275,11 +279,11 @@
                 ":%s 250 %s :Highest connection count: %d (%d clients) (%d connections received)",
 /* 251 RPL_LUSERCLIENT, */
                 ":%s 251 %s :There are %d users and %d invisible on %d servers",
-/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :IRC Operators online",
+/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :IRC Operators and Helpers online",
 /* 253 RPL_LUSERUNKNOWN, */     ":%s 253 %s %d :unknown connection(s)",
 /* 254 RPL_LUSERCHANNELS, */    ":%s 254 %s %d :channels formed",
 /* 255 RPL_LUSERME, */          ":%s 255 %s :I have %d clients and %d servers",
-/* 256 RPL_ADMINME, */          ":%s 256 %s :Administrative info about %s",
+/* 256 RPL_ADMINME, */          ":%s 256 %s :Administrative INFO about %s",
 /* 257 RPL_ADMINLOC1, */        ":%s 257 %s :%s",
 /* 258 RPL_ADMINLOC2, */        ":%s 258 %s :%s",
 /* 259 RPL_ADMINEMAIL, */       ":%s 259 %s :%s",
@@ -287,13 +291,19 @@
 /* 261 RPL_TRACELOG, */         ":%s 261 %s File %s %d",
 /* 262 RPL_ENDOFTRACE, */       ":%s 262 %s %s :End of TRACE",
 /* 263 RPL_LOAD2HI, */          
-":%s 263 %s %s :Server load is temporarily too heavy. Please wait a while and try again.",
+":%s 263 %s %s :Please wait a while and try again ! Thanks ! /FreedomBG Team/",
 /* 264 */       NULL,
-/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
-/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
+/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current Local  users: %d  Max: %d",
+/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current Global users: %d  Max: %d",
+#ifdef FreedomBG
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified in NS users: %d  Max: %d",
+/* 268 RPL_OSIDUSERS, */        ":%s 268 %s :Current Services and Network Administrators: %d  Max: %d",
+/* 269 RPL_GLIDUSERS, */        ":%s 269 %s :Current NetKeepers and IRCd Developers: %d  Max: %d",
+#else
 /* 267 */       NULL,
 /* 268 */       NULL,
 /* 269 */       NULL,
+#endif
 /* 270 */       NULL,
 /* 271 */       NULL,
 /* 272 */       NULL,
@@ -349,9 +359,15 @@
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
+#ifdef FreedomBG
+/* 325 RPL_SILENCE */           ":%s 325 %s %s :is spam and abuse protected",
+/* 326 RPL_WHOISSVSHINT, */     ":%s 326 %s %s :has identified for: this nick",
+/* 327 RPL_OS_ID, */            ":%s 327 %s %s :is Services and Network Administrator",
+#else
 /* 325 */       NULL,
 /* 326 */       NULL,
 /* 327 */       NULL,
+#endif
 /* 328 */       NULL,
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       NULL,
@@ -405,7 +421,7 @@
 /* 378 */       NULL,
 /* 379 */       NULL,
 /* 380 */       NULL,
-/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered... the Vanity Zone!.",
+/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered...the FreedomBGs Dark Zone!",
 /* 382 RPL_REHASHING, */        ":%s 382 %s %s :Rehashing",
 /* 383 */       NULL,
 /* 384 RPL_MYPORTIS, */         ":%s 384 %s %d :Port to local server is",
@@ -439,7 +455,11 @@
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
+#ifdef FreedomBG
+/* 415 ERR_SERV_NICK, */        ":%s 415 %s %s :- You can not kick(deop) Services!",
+#else
 /* 415 */       NULL,
+#endif
 /* 416 ERR_TOOMANYMATCHES */    ":%s 416 %s %s :output too large, truncated",
 /* 417 */       NULL,
 /* 418 */       NULL,
@@ -477,7 +497,11 @@
 /* 449 */       NULL,
 /* 450 */       NULL,
 /* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
+#ifdef FreedomBG
+/* 452 ERR_NOREPEATING, */      ":%s 452 %s %s :No repeating allowed (+z)",
+#else
 /* 452 */       NULL,
+#endif
 /* 453 */       NULL,
 /* 454 */       NULL,
 /* 455 */       NULL,
@@ -494,8 +518,13 @@
 /* 466 ERR_YOUWILLBEBANNED, */  NULL,
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
 /* 468 */       NULL,
+#ifdef FreedomBG
+/* 469 */			":%s 469 %s %s :This channel is ONLY for Server and Network Administrators!",
+/* 470 */       		":%s 470 %s %s :This channel is ONLY for IRC Operators ane Helpers!",
+#else
 /* 469 */       NULL,
 /* 470 */       NULL,
+#endif
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
@@ -507,7 +536,7 @@
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
 /* 480 */       NULL,
 /* 481 ERR_NOPRIVILEGES, */
-                ":%s 481 %s :Permission Denied - You're not an IRC operator",
+                ":%s 481 %s :Access Denied ! Go home and relax ! /FreedomBG Team/",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
 /* 483 ERR_CANTKILLSERVER, */   ":%s 483 %s :You can't kill a server!",
 /* 484 ERR_RESTRICTED, */       ":%s 484 %s :You are restricted",
@@ -516,12 +545,23 @@
 /* 486 */       NULL,
 /* 487 */       NULL,
 /* 488 */       NULL,
+#ifdef FreedomBG
+/* 489 ERR_NOCOLOR, */ ":%s 489 %s %s :Colors are forbidden on this channel!",
+/* 490 ERR_JOINF, */   ":%s 490 %s %s :Can't join the channel, because your nick is either not regged or too young!",
+#else
 /* 489 */       NULL,
 /* 490 */       NULL,
-/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the twilight zone",
+#endif
+/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the Twilight Zone",
+#ifdef FreedomBG
+/* 492 ERR_NOCTCP, */           ":%s 492 %s %s :CTCP messages from non +v/+o/+h are forbidden!",
+/* 493 ERR_NOTALK, */           ":%s 493 %s %s :You can't talk on this channel, while your nickname is not regged ot regged too recently!",
+/* 494 ERR_NOSPAM, */           ":%s 494 %s %s :You can't send this to the channel, while it contains a spam phrase, if you think it's not contact the admin (/ADMIN)",
+#else
 /* 492 */       NULL,
 /* 493 */       NULL,
 /* 494 */       NULL,
+#endif
 /* 495 */       NULL,
 /* 496 */       NULL,
 /* 497 */       NULL,
@@ -743,7 +783,7 @@
 /* 713 ERR_CHANOPEN */		":%s 713 %s %s :Channel is open.",
 /* 714 ERR_KNOCKONCHAN */	":%s 714 %s %s :You are already on that channel.",
 /* 715 ERR_KNOCKDISABLED */	":%s 715 %s :KNOCKs are disabled.",
-/* 716 RPL_TARGUMODEG */	":%s 716 %s %s :is in +g mode (server-side ignore.)",
+/* 716 RPL_TARGUMODEG */	":%s 716 %s %s :is in (+g) mode (server-side ignore.)",
 /* 717 RPL_TARGNOTIFY */	":%s 717 %s %s :has been informed that you messaged them.",
 /* 718 RPL_UMODEGMSG */		":%s 718 %s %s %s@%s :is messaging you, and you have umode +g.",
 /* 719 */	NULL,
diff -uNrd ircd-ratbox-1.3-1/src/modules.c ircd-1.4-FreedomBG/src/modules.c
--- ircd-ratbox-1.3-1/src/modules.c	Thu Jun 26 10:03:16 2003
+++ ircd-1.4-FreedomBG/src/modules.c	Thu May 13 20:30:28 2004
@@ -590,6 +590,9 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+#ifdef FreedomBG
+	mod_add_cmd(&svshint_msgtab);
+#endif
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
diff -uNrd ircd-ratbox-1.3-1/src/newconf.c ircd-1.4-FreedomBG/src/newconf.c
--- ircd-ratbox-1.3-1/src/newconf.c	Fri Dec 19 12:33:03 2003
+++ ircd-1.4-FreedomBG/src/newconf.c	Thu May 13 20:32:14 2004
@@ -3069,6 +3069,11 @@
 	add_top_conf("exempt", conf_begin_exempt, conf_end_exempt);
 	add_conf_item("exempt", "ip", CF_QSTRING, conf_set_exempt_ip);
 
+#ifdef FreedomBG
+	add_top_conf("spamcheck", NULL, NULL);
+	add_conf_item("spamcheck", "adv_text", CF_QSTRING, add_adv_text);
+#endif
+
 	add_top_conf("gecos", conf_begin_gecos, conf_end_gecos);
 	add_conf_item("gecos", "name", CF_QSTRING, conf_set_gecos_name);
 	add_conf_item("gecos", "reason", CF_QSTRING, conf_set_gecos_reason);
diff -uNrd ircd-ratbox-1.3-1/src/s_conf.c ircd-1.4-FreedomBG/src/s_conf.c
--- ircd-ratbox-1.3-1/src/s_conf.c	Fri Dec 19 12:33:03 2003
+++ ircd-1.4-FreedomBG/src/s_conf.c	Fri May 14 06:30:55 2004
@@ -117,6 +117,17 @@
 /* conf uline link list root */
 struct ConfItem *u_conf = ((struct ConfItem *) NULL);
 
+#ifdef FreedomBG
+struct DCCForb {
+  char *fileext;
+  struct DCCForb *next;
+};
+
+// static struct DCCForb *dccforb = NULL;
+
+static struct DCCForb *quitcheck = NULL;
+#endif
+
 /*
  * conf_dns_callback
  * inputs	- pointer to struct ConfItem
@@ -1279,8 +1290,8 @@
 	DupString(ConfigFileEntry.servlink_path, SLPATH);
 	ConfigFileEntry.egdpool_path = NULL;
 	ConfigFileEntry.use_whois_actually = YES;
-	strlcpy(ConfigFileEntry.default_operstring, "is an IRC Operator",sizeof(ConfigFileEntry.default_operstring));
-	strlcpy(ConfigFileEntry.default_adminstring, "is a Server Administrator", sizeof(ConfigFileEntry.default_adminstring));
+	strlcpy(ConfigFileEntry.default_operstring, "is an IRC Operator and Helper",sizeof(ConfigFileEntry.default_operstring));
+	strlcpy(ConfigFileEntry.default_adminstring, "is a Server and System Administrator", sizeof(ConfigFileEntry.default_adminstring));
 
 	ConfigFileEntry.reject_after_count = 5;
 	ConfigFileEntry.reject_ban_time = 300;
@@ -2575,3 +2586,27 @@
 	return (0);
 }
 
+#ifdef FreedomBG
+void add_adv_text(void *data)
+{
+  struct DCCForb *fileextf;
+  char * param = data;
+  if (!param[0]) return;
+
+  fileextf = (struct DCCForb*) MyMalloc(sizeof(struct DCCForb));
+  DupString(fileextf->fileext, param);
+  fileextf->next = quitcheck;
+  quitcheck = fileextf;
+}
+
+int IsAdvQuit(char *file)
+{
+  struct DCCForb *fileextf;
+
+  for (fileextf = quitcheck; fileextf; fileextf = fileextf->next)
+    if (match(fileextf->fileext, file))
+	  return 1;
+
+  return 0;
+}
+#endif
diff -uNrd ircd-ratbox-1.3-1/src/s_misc.c ircd-1.4-FreedomBG/src/s_misc.c
--- ircd-ratbox-1.3-1/src/s_misc.c	Sat Jun 28 07:39:49 2003
+++ ircd-1.4-FreedomBG/src/s_misc.c	Thu May 13 20:32:35 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_misc.c,v 7.32.2.1 2003/06/28 11:39:49 leeh Exp $
+ *  $Id: s_misc.c,v 8.1 2005/05/22 03:33:00 castello Exp $
  */
 
 #include "stdinc.h"
@@ -52,6 +52,115 @@
 	"Sunday", "Monday", "Tuesday", "Wednesday",
 	"Thursday", "Friday", "Saturday"
 };
+
+#ifdef FreedomBG
+
+
+char* servnicks[] = {
+		 "NS",
+		 "MS",
+                 "CS",
+                 "OS",
+		 "HS",
+		 "AS",
+		 "SS",
+		 "TS",
+	       "INFO",
+           "HOSTSERV",
+	    "NETSERV",
+	    "NETLINK",
+	   "ROOTSERV",
+	        "TCM",
+	        "USR",
+                "BSH",
+           "STATSERV",
+               "SEEN",
+           "SEENSERV",
+          "ADMINSERV",
+          "SPLITSERV",
+	     "GLINER",
+	  "SOCKCLEAN",
+	    "MONITOR",
+	     "GLOBAL",
+	       "SEEN",
+	  	 "X",
+		 "Y"
+};
+#define ARR_SIZE 17 /* number of services' nicks.Increase or decrease as needed */
+
+/* s_check ()
+ * will scan for service-possible nick
+ *               
+ */
+
+long s_check( char * szName )
+{
+    int i = 0;
+    for( i=0;i<ARR_SIZE;i++)
+        if( !strcasecmp(szName, servnicks[i]))
+            return 1;
+    return 0;
+}
+
+/* end of s_check() */
+
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
+
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0';
+      if (m && n) {
+        p++; if (*p == ',') {
+          p++; if (isdigit(*p)) {
+            p++; m = *p>='0' && *p<='6';
+            n = *(p-1)=='1' || *(p-1)=='0';
+            if (m && n) {
+              p++;
+            }
+          }
+        }
+      } else if (*p == ',') {
+        p++; if (isdigit(*p)) {
+          p++; m = *p>='0' && *p<='6';
+          n = *(p-1)=='1' || *(p-1)=='0';
+          if (m && n) {
+            p++;
+          }
+        }
+      }
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
+#endif /* FreedomBG */
 
 char *
 date(time_t lclock)
diff -uNrd ircd-ratbox-1.3-1/src/s_serv.c ircd-1.4-FreedomBG/src/s_serv.c
--- ircd-ratbox-1.3-1/src/s_serv.c	Mon Dec  1 16:00:09 2003
+++ ircd-1.4-FreedomBG/src/s_serv.c	Thu May 13 20:32:59 2004
@@ -73,6 +73,15 @@
 int MaxClientCount = 1;
 int refresh_user_links = 0;
 
+#ifdef FreedomBG
+int CurrentIdentUsers  = 0;
+int MaxIdentUsers  = 0;
+int CurrentOSidUsers = 0;
+int MaxOSidUsers = 0;
+int CurrentGlinerUsers = 0;
+int MaxGlinerUsers = 0;
+#endif
+
 static void start_io(struct Client *server);
 
 static SlinkRplHnd slink_error;
@@ -781,6 +790,10 @@
 sendnick_TS(struct Client *client_p, struct Client *target_p)
 {
 	static char ubuf[12];
+#ifdef FreedomBG
+    dlink_node *nchptr;
+    struct Channel * chptr;
+#endif
 
 	if(!IsPerson(target_p))
 		return;
@@ -799,6 +812,22 @@
 			   ubuf,
 			   target_p->username, target_p->host,
 			   target_p->user->server, target_p->info);
+#ifdef FreedomBG
+		if (IsNSId(target_p))
+			sendto_one(client_p, "SVSHINT NSID %s 1", target_p->name);
+
+        if (IsOSId(target_p))
+	        sendto_one(client_p, "SVSHINT OSID %s 1", target_p->name);
+
+        if (IsGLId(target_p))
+		    sendto_one(client_p, "SVSHINT NK %s 1", target_p->name);
+
+		DLINK_FOREACH(nchptr,target_p->user->nokick.head)
+	    {
+			chptr = nchptr->data;
+			sendto_one(client_p,"SVSHINT NOKICK %s %s 1",target_p->name,chptr->chname);
+	    }
+#endif
 }
 
 /*
diff -uNrd ircd-ratbox-1.3-1/src/s_user.c ircd-1.4-FreedomBG/src/s_user.c
--- ircd-ratbox-1.3-1/src/s_user.c	Thu Dec  4 15:30:38 2003
+++ ircd-1.4-FreedomBG/src/s_user.c	Fri May 14 07:32:58 2004
@@ -92,6 +92,11 @@
 	{UMODE_EXTERNAL, 'x'},
 	{UMODE_SPY, 'y'},
 	{UMODE_OPERWALL, 'z'},
+#ifdef FreedomBG
+	{FLAGS_SILENCE, 'S'},
+    {FLAGS_TRANSWIN, 'T'},
+	{FLAGS_TRANSISO, 'Y'},
+#endif
 	{UMODE_OPERSPY, 'Z'},
 	{0, 0}
 };
@@ -122,13 +127,22 @@
 	0,			/* P */
 	0,			/* Q */
 	0,			/* R */
+#ifdef FreedomBG
+    FLAGS_SILENCE,		/* S */
+	FLAGS_TRANSWIN,		/* T */
+#else
 	0,			/* S */
 	0,			/* T */
+#endif
 	0,			/* U */
 	0,			/* V */
 	0,			/* W */
 	0,			/* X */
+#ifdef FreedomBG
+    FLAGS_TRANSISO, 	/* Y */
+#else
 	0,			/* Y */
+#endif
 	UMODE_OPERSPY,		/* Z 0x5A */
 	0, 0, 0, 0, 0,		/* 0x5F */
 	/* 0x60 */ 0,
@@ -214,6 +228,16 @@
 
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
 		   Count.total, Count.max_tot);
+#ifdef FreedomBG
+    sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, source_p->name,
+             CurrentIdentUsers, MaxIdentUsers);
+
+    sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, source_p->name,
+             CurrentOSidUsers, MaxOSidUsers);
+
+    sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+             CurrentGlinerUsers, MaxGlinerUsers);
+#endif
 
 	if(!ConfigServerHide.hide_servers || IsOper(source_p))
 		sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
@@ -1026,6 +1050,14 @@
 				break;
 			}
 
+#ifdef FreedomBG
+	if (MyConnect(source_p) && !(setflags & FLAGS_SILENCE) && (HasSilence(source_p)))
+	{
+	    sendto_one(source_p,":%s NOTICE %s :You have put Silence mode on your nickname (+S). You will NOT receive any private messages, ctcps, notices from unregistered (too recently registered) nicknames",
+				   me.name, parv[0]);
+	}
+#endif
+
 	if(badflag)
 		sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
 
@@ -1152,6 +1184,9 @@
 void
 user_welcome(struct Client *source_p)
 {
+#ifdef FreedomBG
+	struct Client * cptr;
+#endif
 	sendto_one(source_p, form_str(RPL_WELCOME), me.name, source_p->name,
 		   ServerInfo.network_name, source_p->name);
 	sendto_one(source_p, form_str(RPL_YOURHOST), me.name, source_p->name,
@@ -1183,6 +1218,53 @@
 	}
 	else
 		SendMessageFile(source_p, &ConfigFileEntry.motd);
+
+#ifdef FreedomBG
+	if (!(cptr = find_client("NS")) || !(cptr = find_client("CS"))) {
+		sendto_one(source_p, "NOTICE %s :*** Notice -- IRC Services [CS,NS,OS] are currently down!",
+		           source_p->name);
+                sendto_one(source_p, "NOTICE %s :*** Notice -- Do not try to identify your nick!",
+                           source_p->name);
+                sendto_one(source_p, "NOTICE %s :*** Notice -- Do not try to register a new channel or nick!",
+                           source_p->name);
+	}
+#endif
+
+#ifdef FreedomBG
+        if (!(cptr = find_client("NetServ")) || !(cptr = find_client("SplitServ"))) {
+                sendto_one(source_p, "NOTICE %s :*** Notice -- Statistics Services are currently down!",
+                           source_p->name);
+        }
+#endif
+
+#ifdef FreedomBG
+        if (!(cptr = find_client("SeenServ"))) {
+                sendto_one(source_p, "NOTICE %s :*** Notice -- SeenServ is currently down!",
+                           source_p->name);
+        }
+#endif
+
+#ifdef FreedomBG
+        if (!(cptr = find_client("Gliner"))) {
+                sendto_one(source_p, "NOTICE %s :*** Notice -- Gliner is currently down!",
+                           source_p->name);
+        }
+#endif
+
+#ifdef FreedomBG
+        if ((cptr = find_client("castello"))) {
+                sendto_one(source_p, "NOTICE %s :*** WARNING -- castello [The IRCd® Developer] is currently online!",
+                           source_p->name);
+        }
+#endif
+
+#ifdef FreedomBG
+        if ((cptr = find_client("php|aL"))) {
+                sendto_one(source_p, "NOTICE %s :*** WARNING -- php|aL [The Service® Developer] is currently online!",
+                           source_p->name);
+        }
+#endif
+
 
 	if(IsRestricted(source_p))
 	{
